'''
Created on Nov 27, 2013

@author: goergen
'''
import pylab
import numpy
from fractions import gcd


def updateOrder(lines,leftY,rightY,order,label):
    if (leftY in lines):
        if (rightY in lines[leftY]) and (lines[leftY][rightY]["order"]<order):
            lines[leftY][rightY]={"order":order, "label":label}
        else:
            lines[leftY][rightY]={"order":order, "label":label}
    else:
        lines[leftY]={}
        lines[leftY][rightY]={"order":order, "label":label}
def plotTuneDiagram(maxOrder,xlim=[0,1],ylim=[0,1],tickOrders=False,tuneLineColor="black"):
    ylim=numpy.array(ylim)
    xlim=numpy.array(xlim)
    lines={}
    vlines={}
    for a in numpy.arange(-maxOrder,maxOrder,dtype="float"):
        for b in numpy.arange(-maxOrder,maxOrder,dtype="float"):
            for n in numpy.arange(-maxOrder,maxOrder,dtype="float"):
                order=abs(a)+abs(b)
                if order <= maxOrder:
                    if b != 0:
                        leftY  = (n - a*xlim[0]) / b
                        rightY = (n - a*xlim[1]) / b
                        if (ylim[0] <= leftY and ylim[1] >= rightY)or\
                           (ylim[1] >= leftY and ylim[0] <= rightY):
                            divisor=gcd(abs(n),abs(b))
                            updateOrder(lines,leftY,rightY,order,"$\\frac{%d}{%d}$" % (abs(n/divisor),abs(b/divisor)))
                    elif b==0 and a!=0:
                        if xlim[0]<=(1.*n/a)<=xlim[1]:
                            divisor=gcd(abs(n),abs(a))
                            if (1.*n/a) in vlines:
                                if vlines[1.*n/a]["order"]>order:
                                    vlines[1.*n/a]={"order":max(vlines[1.*n/a]["order"],order),"label":"$\\frac{%d}{%d}$" % (n/divisor,a/divisor)}
                            else:
                                vlines[1.*n/a]={"order":order,"label":"$\\frac{%d}{%d}$" % (abs(n/divisor),abs(a/divisor))}
    y2ticks=[]
    y2labels=[]
    for leftY in lines:
        for rightY in lines[leftY]:
            pylab.plot(xlim,[leftY,rightY],linewidth=5./lines[leftY][rightY]["order"],color=tuneLineColor)
            if rightY==leftY:
                y2ticks.append(rightY)
                y2labels.append(lines[leftY][rightY]["label"])
    x2ticks=[]
    x2labels=[]
    for fraction in vlines:
        pylab.axvline(fraction,linewidth=5./vlines[fraction]["order"],color=tuneLineColor)
        x2ticks.append(fraction)
        x2labels.append(vlines[fraction]["label"])
    if tickOrders:
        pylab.xticks(x2ticks,x2labels)
        pylab.yticks(y2ticks,y2labels)
    pylab.xlim(xlim)
    pylab.ylim(ylim)
        
if __name__ == '__main__':
    from  optparse import OptionParser
    parser = OptionParser()
    parser.add_option("-o", "--order", dest="order", help="order for plot", metavar="ORDER",type="int")

    (options, args) = parser.parse_args()
    pylab.figure(figsize=(8,8))
    ax=pylab.subplot(111,aspect="equal")
    plotTuneDiagram(options.order,xlim=[.65,.76],ylim=[.65,.76])
    pylab.show()